using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace WindowsApplication1
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TextBox textUserExpression;
		private System.Windows.Forms.TextBox textResult;
		private System.Windows.Forms.TextBox textDefine;
		private System.Windows.Forms.TextBox textSumMax;
		private System.Windows.Forms.TextBox textSumExpression;
		private System.Windows.Forms.TextBox textSumResult;
		private System.Windows.Forms.CheckBox checkBoxInvalidOp;
		private System.Windows.Forms.CheckBox checkBoxDenormalOp;
		private System.Windows.Forms.CheckBox checkBoxDivisionBy0;
		private System.Windows.Forms.CheckBox checkBoxOverflow;
		private System.Windows.Forms.CheckBox checkBoxUnderflow;
		private System.Windows.Forms.CheckBox checkBoxPrecisionLoss;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.CheckBox checkBox1;
		private System.Windows.Forms.Label labelElapsedTime;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.TextBox textPlotEq;
		private System.Windows.Forms.Button buttonPlot;
		private System.Windows.Forms.Button buttonDefine;
		private System.Windows.Forms.Button buttonEvaluate;
		private System.Windows.Forms.Button buttonSpeedTest;
		private System.Windows.Forms.CheckBox checkBoxSampleExpr;
		
		public Graphics g;				
		public Pen myPen = new Pen(Color.Black);

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.textUserExpression = new System.Windows.Forms.TextBox();
			this.textResult = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.textDefine = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.textSumMax = new System.Windows.Forms.TextBox();
			this.textSumExpression = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.textSumResult = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.checkBoxInvalidOp = new System.Windows.Forms.CheckBox();
			this.checkBoxDenormalOp = new System.Windows.Forms.CheckBox();
			this.checkBoxDivisionBy0 = new System.Windows.Forms.CheckBox();
			this.checkBoxOverflow = new System.Windows.Forms.CheckBox();
			this.checkBoxUnderflow = new System.Windows.Forms.CheckBox();
			this.checkBoxPrecisionLoss = new System.Windows.Forms.CheckBox();
			this.label7 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.labelElapsedTime = new System.Windows.Forms.Label();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.textPlotEq = new System.Windows.Forms.TextBox();
			this.buttonPlot = new System.Windows.Forms.Button();
			this.buttonDefine = new System.Windows.Forms.Button();
			this.buttonEvaluate = new System.Windows.Forms.Button();
			this.buttonSpeedTest = new System.Windows.Forms.Button();
			this.checkBoxSampleExpr = new System.Windows.Forms.CheckBox();
			this.SuspendLayout();
			// 
			// textUserExpression
			// 
			this.textUserExpression.Location = new System.Drawing.Point(104, 16);
			this.textUserExpression.Name = "textUserExpression";
			this.textUserExpression.Size = new System.Drawing.Size(152, 20);
			this.textUserExpression.TabIndex = 0;
			this.textUserExpression.Text = "3+4/5-8";
			// 
			// textResult
			// 
			this.textResult.Location = new System.Drawing.Point(104, 40);
			this.textResult.Name = "textResult";
			this.textResult.Size = new System.Drawing.Size(152, 20);
			this.textResult.TabIndex = 1;
			this.textResult.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(96, 23);
			this.label1.TabIndex = 2;
			this.label1.Text = "User expression:";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(56, 40);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(40, 23);
			this.label2.TabIndex = 3;
			this.label2.Text = "Result:";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(280, 16);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(80, 23);
			this.label3.TabIndex = 5;
			this.label3.Text = "User definition:";
			// 
			// textDefine
			// 
			this.textDefine.Location = new System.Drawing.Point(368, 16);
			this.textDefine.Name = "textDefine";
			this.textDefine.Size = new System.Drawing.Size(200, 20);
			this.textDefine.TabIndex = 6;
			this.textDefine.Text = "Var: MyVariable = 1234.5";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 176);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(112, 23);
			this.label4.TabIndex = 8;
			this.label4.Text = "Summation from 1 to ";
			// 
			// textSumMax
			// 
			this.textSumMax.Location = new System.Drawing.Point(120, 176);
			this.textSumMax.Name = "textSumMax";
			this.textSumMax.Size = new System.Drawing.Size(136, 20);
			this.textSumMax.TabIndex = 9;
			this.textSumMax.Text = "100000";
			// 
			// textSumExpression
			// 
			this.textSumExpression.Location = new System.Drawing.Point(80, 200);
			this.textSumExpression.Name = "textSumExpression";
			this.textSumExpression.Size = new System.Drawing.Size(176, 20);
			this.textSumExpression.TabIndex = 10;
			this.textSumExpression.Text = "x^2+5*x-10";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 200);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(64, 23);
			this.label5.TabIndex = 11;
			this.label5.Text = "Expression:";
			// 
			// textSumResult
			// 
			this.textSumResult.Location = new System.Drawing.Point(80, 224);
			this.textSumResult.Name = "textSumResult";
			this.textSumResult.Size = new System.Drawing.Size(176, 20);
			this.textSumResult.TabIndex = 12;
			this.textSumResult.Text = "";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(8, 224);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(64, 23);
			this.label6.TabIndex = 13;
			this.label6.Text = "Sum result:";
			// 
			// checkBoxInvalidOp
			// 
			this.checkBoxInvalidOp.Checked = true;
			this.checkBoxInvalidOp.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxInvalidOp.Location = new System.Drawing.Point(360, 120);
			this.checkBoxInvalidOp.Name = "checkBoxInvalidOp";
			this.checkBoxInvalidOp.TabIndex = 15;
			this.checkBoxInvalidOp.Text = "Invalid Op";
			this.checkBoxInvalidOp.CheckedChanged += new System.EventHandler(this.checkBoxInvalidOp_CheckedChanged);
			// 
			// checkBoxDenormalOp
			// 
			this.checkBoxDenormalOp.Checked = true;
			this.checkBoxDenormalOp.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxDenormalOp.Location = new System.Drawing.Point(360, 136);
			this.checkBoxDenormalOp.Name = "checkBoxDenormalOp";
			this.checkBoxDenormalOp.TabIndex = 16;
			this.checkBoxDenormalOp.Text = "Denormal Op";
			this.checkBoxDenormalOp.CheckedChanged += new System.EventHandler(this.checkBoxDenormalOp_CheckedChanged);
			// 
			// checkBoxDivisionBy0
			// 
			this.checkBoxDivisionBy0.Checked = true;
			this.checkBoxDivisionBy0.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxDivisionBy0.Location = new System.Drawing.Point(360, 152);
			this.checkBoxDivisionBy0.Name = "checkBoxDivisionBy0";
			this.checkBoxDivisionBy0.TabIndex = 17;
			this.checkBoxDivisionBy0.Text = "Division by 0";
			this.checkBoxDivisionBy0.CheckedChanged += new System.EventHandler(this.checkBoxDivisionBy0_CheckedChanged);
			// 
			// checkBoxOverflow
			// 
			this.checkBoxOverflow.Checked = true;
			this.checkBoxOverflow.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxOverflow.Location = new System.Drawing.Point(464, 120);
			this.checkBoxOverflow.Name = "checkBoxOverflow";
			this.checkBoxOverflow.TabIndex = 18;
			this.checkBoxOverflow.Text = "Overflow";
			this.checkBoxOverflow.CheckedChanged += new System.EventHandler(this.checkBoxOverflow_CheckedChanged);
			// 
			// checkBoxUnderflow
			// 
			this.checkBoxUnderflow.Checked = true;
			this.checkBoxUnderflow.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxUnderflow.Location = new System.Drawing.Point(464, 136);
			this.checkBoxUnderflow.Name = "checkBoxUnderflow";
			this.checkBoxUnderflow.TabIndex = 19;
			this.checkBoxUnderflow.Text = "Underflow";
			this.checkBoxUnderflow.CheckedChanged += new System.EventHandler(this.checkBoxUnderflow_CheckedChanged);
			// 
			// checkBoxPrecisionLoss
			// 
			this.checkBoxPrecisionLoss.Checked = true;
			this.checkBoxPrecisionLoss.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxPrecisionLoss.Location = new System.Drawing.Point(464, 152);
			this.checkBoxPrecisionLoss.Name = "checkBoxPrecisionLoss";
			this.checkBoxPrecisionLoss.TabIndex = 20;
			this.checkBoxPrecisionLoss.Text = "Precision Loss";
			this.checkBoxPrecisionLoss.CheckedChanged += new System.EventHandler(this.checkBoxPrecisionLoss_CheckedChanged);
			// 
			// label7
			// 
			this.label7.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.label7.Location = new System.Drawing.Point(360, 104);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(160, 16);
			this.label7.TabIndex = 21;
			this.label7.Text = "FPU exception masks";
			// 
			// label8
			// 
			this.label8.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.label8.Location = new System.Drawing.Point(128, 152);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(96, 16);
			this.label8.TabIndex = 22;
			this.label8.Text = "Speed test";
			// 
			// checkBox1
			// 
			this.checkBox1.Location = new System.Drawing.Point(368, 64);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.Size = new System.Drawing.Size(200, 24);
			this.checkBox1.TabIndex = 23;
			this.checkBox1.Text = "Show list of sample user definitions";
			this.checkBox1.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
			// 
			// labelElapsedTime
			// 
			this.labelElapsedTime.Location = new System.Drawing.Point(80, 296);
			this.labelElapsedTime.Name = "labelElapsedTime";
			this.labelElapsedTime.Size = new System.Drawing.Size(272, 16);
			this.labelElapsedTime.TabIndex = 24;
			this.labelElapsedTime.Text = "Elapsed time: ";
			// 
			// pictureBox1
			// 
			this.pictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pictureBox1.Location = new System.Drawing.Point(360, 232);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(200, 80);
			this.pictureBox1.TabIndex = 25;
			this.pictureBox1.TabStop = false;
			// 
			// textPlotEq
			// 
			this.textPlotEq.Location = new System.Drawing.Point(360, 200);
			this.textPlotEq.Name = "textPlotEq";
			this.textPlotEq.Size = new System.Drawing.Size(112, 20);
			this.textPlotEq.TabIndex = 26;
			this.textPlotEq.Text = "-sin(x)/2";
			// 
			// buttonPlot
			// 
			this.buttonPlot.Location = new System.Drawing.Point(488, 200);
			this.buttonPlot.Name = "buttonPlot";
			this.buttonPlot.TabIndex = 27;
			this.buttonPlot.Text = "Plot";
			this.buttonPlot.Click += new System.EventHandler(this.buttonPlot_Click);
			// 
			// buttonDefine
			// 
			this.buttonDefine.Location = new System.Drawing.Point(368, 40);
			this.buttonDefine.Name = "buttonDefine";
			this.buttonDefine.TabIndex = 28;
			this.buttonDefine.Text = "Define";
			this.buttonDefine.Click += new System.EventHandler(this.buttonDefine_Click);
			// 
			// buttonEvaluate
			// 
			this.buttonEvaluate.Location = new System.Drawing.Point(104, 72);
			this.buttonEvaluate.Name = "buttonEvaluate";
			this.buttonEvaluate.TabIndex = 29;
			this.buttonEvaluate.Text = "Evaluate";
			this.buttonEvaluate.Click += new System.EventHandler(this.buttonEvaluate_Click);
			// 
			// buttonSpeedTest
			// 
			this.buttonSpeedTest.Location = new System.Drawing.Point(80, 248);
			this.buttonSpeedTest.Name = "buttonSpeedTest";
			this.buttonSpeedTest.Size = new System.Drawing.Size(40, 23);
			this.buttonSpeedTest.TabIndex = 30;
			this.buttonSpeedTest.Text = "Start";
			this.buttonSpeedTest.Click += new System.EventHandler(this.buttonSpeedTest_Click);
			// 
			// checkBoxSampleExpr
			// 
			this.checkBoxSampleExpr.Location = new System.Drawing.Point(184, 72);
			this.checkBoxSampleExpr.Name = "checkBoxSampleExpr";
			this.checkBoxSampleExpr.Size = new System.Drawing.Size(104, 32);
			this.checkBoxSampleExpr.TabIndex = 34;
			this.checkBoxSampleExpr.Text = "Show list of sample expressions";
			this.checkBoxSampleExpr.CheckedChanged += new System.EventHandler(this.checkBoxSampleExpr_CheckedChanged);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(584, 326);
			this.Controls.Add(this.checkBoxSampleExpr);
			this.Controls.Add(this.buttonSpeedTest);
			this.Controls.Add(this.buttonEvaluate);
			this.Controls.Add(this.buttonDefine);
			this.Controls.Add(this.buttonPlot);
			this.Controls.Add(this.textPlotEq);
			this.Controls.Add(this.pictureBox1);
			this.Controls.Add(this.labelElapsedTime);
			this.Controls.Add(this.checkBox1);
			this.Controls.Add(this.label8);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.checkBoxPrecisionLoss);
			this.Controls.Add(this.checkBoxUnderflow);
			this.Controls.Add(this.checkBoxOverflow);
			this.Controls.Add(this.checkBoxDivisionBy0);
			this.Controls.Add(this.checkBoxDenormalOp);
			this.Controls.Add(this.checkBoxInvalidOp);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.textSumResult);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.textSumExpression);
			this.Controls.Add(this.textSumMax);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.textDefine);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.textResult);
			this.Controls.Add(this.textUserExpression);
			this.Name = "Form1";
			this.Text = "uCalc Fast Math Parser 2.96 C# Demo";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		public uCalcNET.uCalcClass uc = new uCalcNET.uCalcClass();

		public uCalcNET.uCalcNET.ucErrCallback d_MyErrorHandler = new uCalcNET.uCalcNET.ucErrCallback(MyErrorHandler);
		static int AlreadyDisplayedOnce = 0;
		static int MyErrorHandler(int t)
		{
			if(AlreadyDisplayedOnce == uCalcNET.uCalcNET.ucFalse)
				MessageBox.Show("Error Handler message: "+ uCalcNET.uCalcNET.ucErrorMessage(0, t) + '\n'
				+ "Offending symbol: " + uCalcNET.uCalcNET.ucErrSymbol(t) + '\n'
				+ "Error Location: " + uCalcNET.uCalcNET.ucErrLocation(t).ToString() + '\n' + '\n'
				+ "This message box will not be displayed for the next error. " + '\n'
				+ "Remove 'AlreadyDisplayedOnce = 1;' in the demo source code to change this. ");

			// Remove the line below if you want the message box to be
			// displayed every time there's an error.
			AlreadyDisplayedOnce = 1;

			return uCalcNET.uCalcNET.ucAbort;
		}

		public uCalcNET.uCalcNET.ucCallback d_MyArea = new uCalcNET.uCalcNET.ucCallback(MyArea);
		static void MyArea(int Expr)
		{
			double MyLength, MyWidth;			

			MyLength = uCalcNET.uCalcNET.ucParam(Expr, 1);
			MyWidth = uCalcNET.uCalcNET.ucParam(Expr, 2);			
   
			if(MyLength < 0) uCalcNET.uCalcNET.ucRaiseErrorMessage(Expr, "Length cannot be negative");
			if(MyWidth  < 0) uCalcNET.uCalcNET.ucRaiseErrorMessage(Expr, "Width cannot be negative");

			uCalcNET.uCalcNET.ucReturn(Expr, MyLength * MyWidth);
		}

  		public uCalcNET.uCalcNET.ucCallback d_MyIIf_Numeric = new uCalcNET.uCalcNET.ucCallback(MyIIf_Numeric);
		static void MyIIf_Numeric(int Expr)
		{
			double Condition;
			int TruePart, FalsePart;

			Condition = uCalcNET.uCalcNET.ucParam(Expr, 1);
			TruePart = uCalcNET.uCalcNET.ucParamHandle(Expr, 2);
			FalsePart = uCalcNET.uCalcNET.ucParamHandle(Expr, 3);

			if(Condition != 0)
			uCalcNET.uCalcNET.ucReturn(Expr, uCalcNET.uCalcNET.ucEvaluate(TruePart));
			else uCalcNET.uCalcNET.ucReturn(Expr, uCalcNET.uCalcNET.ucEvaluate(FalsePart));
		}

		public uCalcNET.uCalcNET.ucCallback d_MyIIf_String = new uCalcNET.uCalcNET.ucCallback(MyIIf_String);
		static void MyIIf_String(int Expr)
		{
			double Condition;
			int TruePart, FalsePart;

			Condition = uCalcNET.uCalcNET.ucParam(Expr, 1);
			TruePart = uCalcNET.uCalcNET.ucParamHandle(Expr, 2);
			FalsePart = uCalcNET.uCalcNET.ucParamHandle(Expr, 3);

			if(Condition != 0)
			uCalcNET.uCalcNET.ucReturnStr(Expr, uCalcNET.uCalcNET.ucEvaluateStr(TruePart));
			else uCalcNET.uCalcNET.ucReturnStr(Expr, uCalcNET.uCalcNET.ucEvaluateStr(FalsePart));
		}

		public uCalcNET.uCalcNET.ucCallback d_Native_MyMsgBox = new uCalcNET.uCalcNET.ucCallback(Native_MsgBox);
		static void Native_MsgBox(int Expr)
		{
			uCalcNET.uCalcNET.ucReturn(Expr, (double)Microsoft.VisualBasic.Interaction.MsgBox(uCalcNET.uCalcNET.ucParamStr(Expr, 1), (Microsoft.VisualBasic.MsgBoxStyle)uCalcNET.uCalcNET.ucParam(Expr, 2), uCalcNET.uCalcNET.ucParamStr(Expr, 3)));
		}

		public uCalcNET.uCalcNET.ucCallback d_MyAverage = new uCalcNET.uCalcNET.ucCallback(MyAverage);
		static void MyAverage(int Expr)
		{
			int x;
			double Total = 0;

			for(x=1; x <= uCalcNET.uCalcNET.ucParamCount(Expr); x++)
				Total = Total + uCalcNET.uCalcNET.ucParam(Expr, x);        

			uCalcNET.uCalcNET.ucReturn(Expr, Total / uCalcNET.uCalcNET.ucParamCount(Expr));
		}

		public uCalcNET.uCalcNET.ucCallback d_MyLeft = new uCalcNET.uCalcNET.ucCallback(MyLeft);
		static void MyLeft(int Expr)
		{		
			uCalcNET.uCalcNET.ucReturnStr(Expr, Microsoft.VisualBasic.Strings.Left(uCalcNET.uCalcNET.ucParamStr(Expr, 1), (int)uCalcNET.uCalcNET.ucParam(Expr, 2)));
		}

		public uCalcNET.uCalcNET.ucCallback d_StringRepeat = new uCalcNET.uCalcNET.ucCallback(StringRepeat);
		static void StringRepeat(int Expr)
		{
			int x;
			string TotalString = "";

			for(x = 1; x <= uCalcNET.uCalcNET.ucParam(Expr, 2); x++)
				TotalString = TotalString + uCalcNET.uCalcNET.ucParamStr(Expr, 1);
        
			uCalcNET.uCalcNET.ucReturnStr(Expr, TotalString);
		}

		public uCalcNET.uCalcNET.ucCallback d_ucSum = new uCalcNET.uCalcNET.ucCallback(ucSum);
		static void ucSum(int Expr)
		{
			int Expression, VarHandle;
			double Start, Finish, sStep;
			double x, Total;

			Expression = uCalcNET.uCalcNET.ucParamHandle(Expr, 1);
			Start = uCalcNET.uCalcNET.ucParam(Expr, 2);
			Finish = uCalcNET.uCalcNET.ucParam(Expr, 3);
			sStep = uCalcNET.uCalcNET.ucParam(Expr, 4);
			VarHandle = uCalcNET.uCalcNET.ucParamHandle(Expr, 5);

			x = Start;
			Total = 0;
			while(x <= Finish)
			{
				uCalcNET.uCalcNET.ucSetVariableValue(VarHandle, x);
				Total = Total + uCalcNET.uCalcNET.ucEvaluate(Expression);
				x = x + sStep;
			}

			uCalcNET.uCalcNET.ucReturn(Expr, Total);
		}

		public uCalcNET.uCalcNET.ucCallback d_ucSolve = new uCalcNET.uCalcNET.ucCallback(ucSolve);
		static void ucSolve(int Expr)
		{
			int Expression, Variable;
			int Iterations = 0;
			double a, b, fa, fb, Value, tmp;

			Expression = uCalcNET.uCalcNET.ucParamHandle(Expr, 1);
			a = uCalcNET.uCalcNET.ucParam(Expr, 2);
			b = uCalcNET.uCalcNET.ucParam(Expr, 3);
			Variable = uCalcNET.uCalcNET.ucParamHandle(Expr, 4);
			Value = 0;

			uCalcNET.uCalcNET.ucSetVariableValue(Variable, a);
			fa = uCalcNET.uCalcNET.ucEvaluate(Expression);

			uCalcNET.uCalcNET.ucSetVariableValue(Variable, b); 
			fb = uCalcNET.uCalcNET.ucEvaluate(Expression);
   
			if(fb < fa) {tmp = a; a = b; b = tmp;}  // swap a, b
    
			while(Math.Abs(b - a) > 0.000000000000001)
			{
				uCalcNET.uCalcNET.ucSetVariableValue(Variable, (a + b) / 2);
      
				Value = uCalcNET.uCalcNET.ucEvaluate(Expression);
      
				if(Value == 0) {a = (a + b) / 2; break;}

				if(Value < 0) a = (a + b) / 2; else b = (a + b) / 2;

				Iterations = Iterations + 1;
				if(Iterations == 100) break;
			}
   
			if(Math.Abs(Value) > 0.0000000001) uCalcNET.uCalcNET.ucRaiseErrorMessage(Expr, "Solution not found");
			uCalcNET.uCalcNET.ucReturn(Expr, a);
		}

		void Test(string Expr, string Answer)
		{
			if(Answer != uc.ucEvalStr(Expr)) MessageBox.Show(Expr + '\n' + uc.ucEvalStr(Expr) + '\n' + Answer, "", 0);
		}

		void TestExpand(string Expr, string Answer)
		{
			if(Answer != uc.ucExpand(Expr)) MessageBox.Show(Expr + '\n' + uc.ucExpand(Expr) + '\n' + Answer, "", 0);
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			g = pictureBox1.CreateGraphics();

			// The definitions here are for "callback" routines.
			// Each definition ends with a delegate for the address of a routine.
			// The actual code for these routines can be found elsewhere in this file.
			// Do a search for MyErrorHandler, for instance, to see the actual code for it.
   
			// The MyErrorHandler() function will be called whenever and wherever an
			// error (such as "Syntax Error") is raised.			
			uCalcNET.uCalcNET.uCalc(uCalcNET.uCalcNET.uc_AddErrorHandler, "", d_MyErrorHandler, 0, 0, uc.t);

			// C# only supports Native callback definitions.  In the demo for other
			// compilers you may notice that some definitions start with "Native: " and others
			// don't.  The presence or absence of the "Native: " keyword has no effect under C#.
			// MyArea() returns the product of multiplying the two arguments.
			// MyLeft() returns the left-most characters of a string.  The second argument represents the number of characters.
			// MsgBox() displays a message box.  The 1st argument is required.  The others are optional.

			uc.ucDefineFunction("MyArea(Length, Width)", d_MyArea);
			uc.ucDefineFunction("MyLeft(Text As String, Count) As String", d_MyLeft);
			uc.ucDefineFunction("MsgBox(Prompt As String, Buttons = 0, Title As String = 'uCalc')", d_Native_MyMsgBox);

			// The three consecutive dots "..." mean that MyAverage can take any number of arguments
			// (however, because "x" is specified, there must be at least one argument).
			uc.ucDefineFunction("MyAverage(x ...)", d_MyAverage);

			// Two versions of MyIIF can co-exist peacefully with the same name because
			// they are defined with different argument types (numeric vs string).
			// By passing the last two arguments ByExpr, the callback can chose to evaluate only one of of them.  
			uc.ucDefineFunction("MyIIf(cond, ByExpr TruePart, ByExpr FalsePart)", d_MyIIf_Numeric);
			uc.ucDefineFunction("MyIIf(cond, ByExpr TruePart As String, ByExpr FalsePart As String) As String", d_MyIIf_String);

			// The following defines the "*" operator so that MyString * n returns MyString repeated n times.
			// For instance, "He " * 3, would return "He He He".  20 represents the precedence level.  It is
			// arbitrarily set at the same level as that of the "*" multiplication operator defined in ucFMP296\DotNet\uCalcNET.vb.
			uc.ucDefineOperator("20 {MyString As String} * {Number} As String", d_StringRepeat);

			// This definition is for a summation.  See the callback ucSum() routine for the
			// actual code, which runs a loop that adds up the total for the expression in
			// the first argument a number of times based on the second and third arguments.
			// For instance Sum(g^2+1, 1, 5, 1, g) returns 60 and Sum(x^2, 1, 10) returns 385.
			// The last two arguments are optional, so they default to 1 and x if omitted.
			//
			// The first argument is passed "ByExpr".  So instead of being evaluated before
			// being passed to the callback the way an ordinary argument would be, a handle
			// for the expression is passed so that the callback can evaluate it (in this
			// case numerous times).
			//
			// The last argument is passed "ByHandle".  This causes the callback to receive
			// a handle for the variable being passed, in such a way that it can be linked to
			// the summation counter, and integrated into the expression in the first argument.
			//
			// The actual function being defined is Sum_().  Then a syntax construct named
			// Sum() is defined in such a way that the last argument gets defined as a local
			// variable.  So if you evaluate Sum(x^2, 5, 10, 1, x), the local "x" in this
			// expression will not interfere with a pre-existing variable named x.  Also you
			// do not need to declare a variable ahead of time to use it as a counter for Sum().
			uc.ucDefineFunction("Native: Sum_(ByExpr Expr, Start, Finish, Step, ByHandle Var)", d_ucSum);
			uc.ucDefineSyntax("Sum({Expr}, {Start}, {Finish} [, {Step=1} [, {Var=x}]])"
					+"::= Local({Var}, Sum_({Expr}, {Start}, {Finish}, {Step}, {Var}))");

			// The following routine solves an equation.
			// The callback code is based on the Bisection Method algorithm.
			// The concept here is very similar to that of Sum().
			// Two syntax constructs are defined.  The second one rearranges the equation
			// if it includes an equal sign.
			// For instance Solve(x^2 = 9+x) becomes Solve(x^2 - (9+x))
			// Solve(x^2 + 1 = 26) returns 5.
			// Solve(x^2 + 1 = 26, -1000, 0) returns -5.
			uc.ucDefineFunction("Native: Solve_(ByExpr Expr, a, b, ByHandle Var)", d_ucSolve);
			uc.ucDefineSyntax("Solve({Expr} [, {a=-100000000} [, {b=100000000} [, {Var=x}]]]) "
                            + "::= Local({Var}, Solve_({Expr}, {a}, {b}, {Var}))");
			uc.ucDefineSyntax("Solve({Left} = {Right} [, {etc}]) ::= Solve({Left}-({Right}) {etc: , {etc}})");

		}

		private void checkBoxInvalidOp_CheckedChanged(object sender, System.EventArgs e)
		{
			uc.uCalc(uCalcNET.uCalcNET.uc_ToggleFPU, "", uCalcNET.uCalcNET.uc_FPU_Mask_InvalidOp);
		}

		private void checkBoxDenormalOp_CheckedChanged(object sender, System.EventArgs e)
		{
			uc.uCalc(uCalcNET.uCalcNET.uc_ToggleFPU, "", uCalcNET.uCalcNET.uc_FPU_Mask_DenormalOp);
		}

		private void checkBoxDivisionBy0_CheckedChanged(object sender, System.EventArgs e)
		{
			uc.uCalc(uCalcNET.uCalcNET.uc_ToggleFPU, "", uCalcNET.uCalcNET.uc_FPU_Mask_ZeroDivide);
		}

		private void checkBoxOverflow_CheckedChanged(object sender, System.EventArgs e)
		{
			uc.uCalc(uCalcNET.uCalcNET.uc_ToggleFPU, "", uCalcNET.uCalcNET.uc_FPU_Mask_Overflow);
		}

		private void checkBoxUnderflow_CheckedChanged(object sender, System.EventArgs e)
		{
			uc.uCalc(uCalcNET.uCalcNET.uc_ToggleFPU, "", uCalcNET.uCalcNET.uc_FPU_Mask_Underflow);
		}

		private void checkBoxPrecisionLoss_CheckedChanged(object sender, System.EventArgs e)
		{
			uc.uCalc(uCalcNET.uCalcNET.uc_ToggleFPU, "", uCalcNET.uCalcNET.uc_FPU_Mask_PrecisionLoss);
		}

		private void checkBox1_CheckedChanged(object sender, System.EventArgs e)
		{			
			Microsoft.VisualBasic.Interaction.Shell("Notepad DemoDefs.Txt", Microsoft.VisualBasic.AppWinStyle.NormalFocus, false,0);
		}

		public float OldX, OldY;
		private void CartesianLineTo(float x, float y)
		{
			float NewX, NewY;						 
			
			if(x == -10) { OldX = 0 ; OldY = 0; }

			NewX = pictureBox1.Size.Width * (x + 10) / 20;
			NewY = pictureBox1.Size.Height * (2 - y) / 4;

			g.DrawLine(myPen, OldX, OldY, NewX, NewY);

			OldX = NewX;
			OldY = NewY;
		}	

		private void buttonPlot_Click(object sender, System.EventArgs e)
		{
			float x = -10;
			int EqHandle, xHandle;
			
			g.Clear(pictureBox1.BackColor);

			xHandle = uc.ucDefineVariable("x");
			EqHandle = uc.ucParse(textPlotEq.Text);

			while (x <= 10)
			{
				uCalcNET.uCalcNET.ucSetVariableValue(xHandle, x);
				CartesianLineTo(x, (float)uCalcNET.uCalcNET.ucEvaluate(EqHandle));
				x = x + (float)0.125;
			}      
        
			uCalcNET.uCalcNET.ucReleaseItem(EqHandle);
			uCalcNET.uCalcNET.ucReleaseItem(xHandle);	
		}

		private void buttonDefine_Click(object sender, System.EventArgs e)
		{
			// ucDefine can define a variable, function, operator, syntax construct,
			// constant, pattern, data type, and more.
			//
			// Examples:
			//
			// ucDefine("Var: MyVariable As String");
			// ucDefine("Func: Area(Length, Width) = Length * Width");
			// ucDefine("Op: 50 {x}%  :=  x / 100");   // 50 is an arbitrary precedence level.
			// ucDefine("Syntax: {a} + {a} ::= 'Two {a}s are better than one {a}'");
			// ucDefine("Const: Pi = Atan(1) * 4");
			uc.ucDefine(textDefine.Text);
		}

		private void buttonEvaluate_Click(object sender, System.EventArgs e)
		{
			// ucEval() evaluates an expression and returns a numeric result.
			// ucEvalStr() can evaluate expressions of any data type (numeric, string, or other).
			// If the result is numeric ucEvalStr conveniently converts it to a string for you.
			textResult.Text = uc.ucEvalStr(textUserExpression.Text);
		}

		unsafe private void buttonSpeedTest_Click(object sender, System.EventArgs e)
		{
			int ExprHandle, xHandle;
			double x = 1, SumTotal = 0, SumMax, TimerStart, TimerEnd;   
   
			
			// Un-comment the following line if you prefer not to use the C# "unsafe" mode
			// xHandle = uc.ucDefineVariable("x");

			// Remove the following line if you prefer not to use the C# "unsafe" mode
			xHandle = uc.ucDefineVariable("x", (int)&x);

			ExprHandle = uc.ucParse(textSumExpression.Text);
			SumMax = System.Convert.ToDouble(textSumMax.Text);			

			TimerStart = Microsoft.VisualBasic.DateAndTime.Timer;
			while (x <= SumMax)
			{
				// Un-comment the following line if you prefer not to use the C# "unsafe" mode
				// uCalcNET.uCalcNET.ucSetVariableValue(xHandle, x);
				SumTotal = SumTotal + uCalcNET.uCalcNET.ucEvaluate(ExprHandle);
				x++;
			}
			TimerEnd = Microsoft.VisualBasic.DateAndTime.Timer - TimerStart;
     
			textSumResult.Text = System.Convert.ToString(SumTotal);
			labelElapsedTime.Text = "Elapsed Time:  " + System.Convert.ToString(TimerEnd);
   
			uCalcNET.uCalcNET.ucReleaseItem(ExprHandle);
			uCalcNET.uCalcNET.ucReleaseItem(xHandle);		
		}		

		private void checkBoxSampleExpr_CheckedChanged(object sender, System.EventArgs e)
		{
			Microsoft.VisualBasic.Interaction.Shell("Notepad DemoExpr.Txt", Microsoft.VisualBasic.AppWinStyle.NormalFocus, false,0);
		}
	}
}
