Public Class uCalcClass
    Public t As Integer

    Sub New()
        uCalc(uc_SetDefaultThread, "", 0)
        t = ucInitialize()
    End Sub
    Protected Overrides Sub Finalize()
        ucReleaseItem(t)
    End Sub

    Public Function uCalc(ByVal ucCommand As Integer, ByVal TextArg As String, _
                          ByVal MiscArg1 As Integer, ByVal MiscArg2 As Integer, _
                          ByVal ReturnPtr As Integer, ByVal LastArg As Integer) As Integer
        uCalc = uCalc_(ucCommand, TextArg, MiscArg1, MiscArg2, ReturnPtr, LastArg)
    End Function

    Public Function uCalc(ByVal ucCommand As Integer, ByVal TextArg As String, _
                              ByVal MiscArg1 As Integer, ByVal MiscArg2 As Integer, _
                              ByVal ReturnPtr As Integer) As Integer
        uCalc = uCalc_(ucCommand, TextArg, MiscArg1, MiscArg2, ReturnPtr, t)
    End Function

    Public Function uCalc(ByVal ucCommand As Integer, ByVal TextArg As String, _
                            ByVal MiscArg1 As Integer, ByVal MiscArg2 As Integer) As Integer
        uCalc = uCalc_(ucCommand, TextArg, MiscArg1, MiscArg2, 0, t)
    End Function

    Public Function uCalc(ByVal ucCommand As Integer, ByVal TextArg As String, _
                            ByVal MiscArg1 As Integer) As Integer
        uCalc = uCalc_(ucCommand, TextArg, MiscArg1, 0, 0, t)
    End Function

    Public Function uCalc(ByVal ucCommand As Integer, ByVal TextArg As String) As Integer
        uCalc = uCalc_(ucCommand, TextArg, 0, 0, 0, t)
    End Function

    Public Function uCalc(ByVal ucCommand As Integer) As Integer
        uCalc = uCalc__(ucCommand, 0, 0, 0, 0, t)
    End Function

    Public Function ucDefine(ByVal Definition As String, ByVal Arg1 As Integer, ByVal Arg2 As Integer, ByVal Arg3 As Integer) As Integer
        ucDefine = uCalc(uc_Define, Definition, Arg1, Arg2, Arg3, t)
    End Function

    Public Function ucDefine(ByVal Definition As String, ByVal Arg1 As Integer, ByVal Arg2 As Integer) As Integer
        ucDefine = uCalc(uc_Define, Definition, Arg1, Arg2, 0, t)
    End Function

    Public Function ucDefine(ByVal Definition As String, ByVal Arg1 As Integer) As Integer
        ucDefine = uCalc(uc_Define, Definition, Arg1, 0, 0, t)
    End Function

    Public Function ucDefine(ByVal Definition As String) As Integer
        ucDefine = uCalc(uc_Define, Definition, 0, 0, 0, t)
    End Function

    Public Function ucDefineFunction(ByVal Definition As String, ByVal CallbackAddress As Integer) As Integer
        Definition = "Func:: " + Definition + " At " + Str$(CallbackAddress)
        ucDefineFunction = uCalc(uc_Define, "Func:: " + Definition, CallbackAddress, 0, 0, t)
    End Function

    Public Function ucDefineFunction(ByVal Definition As String, ByVal CallbackAddress As ucCallback) As Integer
        If ucIsInitialized = ucFalse Then Call ucInitialize()
        ucDefineFunction = uCalc____(uc_Define, "Func:: " + Definition, CallbackAddress, 0, 0, t)
    End Function

    Public Function ucDefineFunction(ByVal Definition As String) As Integer
        ucDefineFunction = uCalc(uc_Define, "Func: " + Definition, 0, 0, 0, t)
    End Function

    Public Function ucDefineOperator(ByVal Definition As String, ByVal CallbackAddress As ucCallback) As Integer
        If ucIsInitialized = ucFalse Then Call ucInitialize()
        ucDefineOperator = uCalc____(uc_Define, "Op:: " + Definition, CallbackAddress, 0, 0, t)
    End Function

    Public Function ucDefineOperator(ByVal Definition As String) As Integer
        ucDefineOperator = uCalc(uc_Define, "Op: " + Definition, 0, 0, 0, t)
    End Function

    Public Function ucDefineSyntax(ByVal Definition As String, ByVal Rank As Integer) As Integer
        ucDefineSyntax = uCalc(uc_DefineSyntax, Definition, Rank, 0, 0, t)
    End Function

    Public Function ucDefineSyntax(ByVal Definition As String) As Integer
        ucDefineSyntax = uCalc(uc_DefineSyntax, Definition, 1, 0, 0, t)
    End Function

    Public Function ucDefineVariable(ByVal Definition As String, ByVal VarAddress As Integer) As Integer
        Definition = "Var: " + Definition + " At " + Str$(VarAddress)
        ucDefineVariable = uCalc(uc_Define, Definition, 0, 0, 0, t)
    End Function

    Public Function ucDefineVariable(ByVal Definition As String) As Integer
        Definition = "Var: " + Definition
        ucDefineVariable = uCalc(uc_Define, Definition, 0, 0, 0, t)
    End Function

    Public Function ucEval(ByVal Expr As String) As Double
        Dim ItemPtr As Integer

        ItemPtr = ucParse(Expr, 0)
        ucEval = ucEvaluate(ItemPtr)
        ucReleaseItem(ItemPtr)
    End Function

    Public Function ucEvalStr(ByVal Expr As String, ByVal ExprType As Integer) As String
        ucEvalStr = uCalcStr(uc_EvalStr, Expr, ExprType, 0, 0, t)
    End Function

    Public Function ucEvalStr(ByVal Expr As String) As String
        ucEvalStr = uCalcStr(uc_EvalStr, Expr, 0, 0, 0, t)
    End Function

    Public Function ucEvaluateStr(ByVal Item As Integer) As String
        ucEvaluateStr = ucStrReturn(uCalcB(uc_EvaluateStr, 0, Item))
    End Function

    Public Function ucExpand(ByVal Expr As String) As String
        ucExpand = uCalcStr(uc_Expand, Expr, 0, 0, 0, t)
    End Function

    Public Function ucErrorMessage(ByVal ErrNum As Integer) As String
        ucErrorMessage = ucStrReturn(uCalcB(uc_GetErrorMessage, 0, ErrNum, 0, 0, t))
    End Function

    Public Function ucErrorMessage() As String
        ucErrorMessage = ucStrReturn(uCalcB(uc_GetErrorMessage, 0, 0, 0, 0, t))
    End Function

    Public Function ucGetError() As Integer
        ucGetError = uCalcB(uc_GetErrorNumber, 0, 0, 0, 0, t)
    End Function
    Public Function ucError() As Integer
        ucError = uCalcB(uc_GetErrorNumber, 0, 0, 0, 0, t)
    End Function
    Public Function ucSetError(ByVal ErrorNum As Integer) As Integer
        ucSetError = uCalcB(uc_SetErrorNumber, 0, ErrorNum, 0, 0, t)
    End Function


    Public Function ucGetExpr() As String
        ucGetExpr = ucStrReturn(uCalcB(uc_GetExpression, 0, 0, 0, 0, t))
    End Function

    'Public Function ucGetNextItem(ByVal Expr As String, ByRef i As Integer) As String
    '      ucGetNextItem = uCalcStr(uc_GetNextItem, Expr, 0, 0, VarPtr(i), t)
    'End Function

    Public Function ucGetSymbol() As String
        ucGetSymbol = ucStrReturn(uCalcB(uc_GetSymbol, 0, 0, 0, 0, t))
    End Function

    Public Function ucGetItemHandle(ByVal SymbolName As String, ByVal ucProperties As Integer) As Integer
        ucGetItemHandle = uCalc(uc_GetItemData, SymbolName, 0, uc_Handle, ucProperties, t)
    End Function

    Public Function ucGetItemHandle(ByVal SymbolName As String) As Integer
        ucGetItemHandle = uCalc(uc_GetItemData, SymbolName, 0, uc_Handle, 0, t)
    End Function

    'Public Function ucInterpret(ByVal Expr As String, Optional ByVal ExprType As Integer = 0) As String
    '    ucInterpret = uCalcStr(uc_EvalStr, Expr, ExprType, 1, 0, t)
    'End Function

    'Public Function ucNewThread(Optional ByVal ParentThread As Integer = 0) As Integer
    '    ucNewThread = uCalcB(uc_NewThread, 0, ParentThread)
    'End Function

    Public Function ucParse(ByVal Expr As String, ByVal ExprType As Integer) As Integer
        ucParse = uCalc(uc_Parse, Expr, ExprType, 0, 0, t)
    End Function

    Public Function ucParse(ByVal Expr As String) As Integer
        ucParse = uCalc(uc_Parse, Expr, 0, 0, 0, t)
    End Function

    Public Function ucReleaseItem(ByVal ucItem As Integer) As Integer
        ucReleaseItem = uCalcB(uc_ReleaseItem, 0, ucItem)
    End Function

    Public Function ucSetErrMsg(ByVal ErrIndex As Integer, ByVal ErrMessage As String) As Integer
        ucSetErrMsg = uCalc(uc_SetErrorMessage, ErrMessage, ErrIndex, 0, 0, t)
    End Function

    Public Function ucSetErrorNumber(ByVal ErrorNumber As Integer) As Integer
        ucSetErrorNumber = uCalcB(uc_SetErrorNumber, 0, ErrorNumber, 0, 0, t)
    End Function
End Class

